(() => {
    'use strict';

    // We're not worried about putting a counter and a list on the prototype here because each process ends
    // directly after the Promises are resolved and there is only ever one 'child' object created at a time.
    module.exports = Object.create(null, {
        indent: {
            value: 0,
            writable: true
        },

        print: {
            value: function (map, verbose) {
                this.indent++;

                for (let entry of map.entries()) {
                    // TODO: Does this need to be optimized?
                    this.captureRow(entry[0], (verbose && entry[1] === true ? 'it' : 'describe'));

                    if (entry[1].size) {
                        this.print(entry[1], verbose);
                    }
                }

                this.indent--;
            }
        },

        rows: {
            value: []
        }
    });
})();

